mountifulcreated = false
function Mountiful_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED")

	--Register Slash Commands
	SLASH_MOUNT1 = "/mountiful"
	SLASH_MOUNT2 = "/mount" -- A shortcut or alias
	SlashCmdList["MOUNT"] = Mountiful_Command

	SLASH_PET1 = "/pet" -- A shortcut or alias
	SlashCmdList["PET"] = function(arg) Mountiful_Command(arg, true); end;

	-- Binding Variables
	BINDING_HEADER_MOUNTIFULHDR = "Mountiful Bindings"
	BINDING_NAME_MOUNTIFULBIND1 = "Ground"
	BINDING_NAME_MOUNTIFULBIND2 = "Flying"
	BINDING_NAME_MOUNTIFULBIND3 = "Other"
	BINDING_NAME_MOUNTIFULBIND4 = "Other2"


end
function Mountiful_OnEvent()
	if (event == "VARIABLES_LOADED") then
		Mountiful_Loaded()
	end
end
function Mountiful_Loaded()
	if Mountiful_Vars and Mountiful_Vars.version == nil then
		Mountiful_Vars = nil
	end
	if Mountiful_Vars == nil then
		Mountiful_Vars = {
			version = 1.3,
			panes = {
				[1] = "Ground",
				[2] = "Flying",
				[3] = "Other",
				[4] = "Other2",
				[5] = "Pet",
			},
			Pet = {
				isPet = true,
			},
			Mounts = {
				count = 0,
				fastflyers = {},
				slowflyers = {},
				fastground = {},
				slowground = {},
			}
		}
	end
	if Mountiful_Vars.version < 1.3 then
		Mountiful_Vars.version = 1.3
		Mountiful_Vars.panes[#Mountiful_Vars.panes+1] = "Pet"
		Mountiful_Vars.Pet = {
			isPet = true,
		}
		Mountiful_Vars.Mounts = {
			count = 0,
			fastflyers = {},
			slowflyers = {},
			fastground = {},
			slowground = {},
		}
	end
end
function Mountiful_GetCommand(msg)
	if msg then
		local a,b,c=strfind(msg, "(%S+)") --contiguous string of non-space characters
		if a then
			return c, strsub(msg, b+2)
		else	
			return ""
		end
	end
end

function Mountiful_Command(msg, isPet)
	local Cmd, SubCmd = Mountiful_GetCommand(msg)
	local tmpcmd, ismountcmd
		for i, panel in pairs(Mountiful_Vars.panes) do
			tmp = strlower(panel)
			if (strlower(Cmd) == tmp) then
				ismountcmd = true
				tmpcmd = panel
				break
			end
		end
		if (ismountcmd) then
			Mountiful_Mount(tmpcmd)
		elseif (Cmd == "hide") then
			Mountiful:Hide()
		elseif (Cmd == "add") then
			Mountiful_AddPanel(SubCmd, isPet)
		elseif (Cmd == "remove") then
			Mountiful_RemovePanel(SubCmd)
		elseif (Cmd == "smart") then
			Mountiful_SmartMount()
		else
			if not mountifulcreated then
				mountifulcreated = true
				Mountiful_CreateOptions()
			end
			Mountiful:Show()
		end
end
function Mountiful_CreateOptions()
	for i, panelname in ipairs(Mountiful_Vars.panes) do
		panel = Mountiful_CreatePanel(i, panelname)
		Mountiful_CreateMountSelectors(panelname, panel)
	end
end
function Mountiful_CreatePanel(i, panelname)
		local parent = getglobal("Mountiful")
		local leftpane = getglobal("Mountiful_LeftPane")
		panel = CreateFrame("Frame", panelname, parent, "RightPane_Template")
		local button = CreateFrame("Button", panelname.."_Button", leftpane, "LeftMenuButton")
		local paneltext = getglobal(panel:GetName().."_Name")
		button:SetText(panelname)
		paneltext:SetText(panelname)
		if i > 1 then
			local lastbutton = getglobal(Mountiful_Vars.panes[i-1].."_Button")
			button:SetPoint("TOP", lastbutton, "BOTTOM", 0, 0)
			panel:Hide()
		end
		return panel
end
local lastpane
function Mountiful_PanelSelect()
	if not lastpane then 
		 lastpane = getglobal(Mountiful_Vars.panes[1]) 
	end
	lastpane:Hide()
	local pane = string.sub(this:GetName(), -0, -8)
	pane = getglobal(pane)
	pane:Show()
	lastpane = pane
end

function Mountiful_CreateMountSelectors(panelname, parent)
	local lastmount, rowfirst
	local companionType = "MOUNT";
	if (Mountiful_Vars[panelname] and Mountiful_Vars[panelname].isPet) then
		companionType = "CRITTER";
	end
	mountnum = GetNumCompanions(companionType)
	for i=1, mountnum do
		local _, mountname, spellID, icon, _ = GetCompanionInfo(companionType, i)
		local mount = CreateFrame("Frame", panelname.."_"..mountname, parent, "Mount")
		local button = getglobal(panelname.."_"..mountname.."_MountIcon")
		local mounttexture = getglobal(panelname.."_"..mountname.."_MountIcon_IconTexture")
		local checkbox = getglobal(panelname.."_"..mountname.."_CheckButton")
		mounttexture:SetTexture(icon)
		checkbox:SetID(i)
		
		if (Mountiful_Vars[panelname]) then
			if (Mountiful_Vars[panelname][mountname]) then
				checkbox:SetChecked(Mountiful_Vars[panelname][mountname]["checked"])
			else
				checkbox:SetChecked(false)
			end
		else
			checkbox:SetChecked(false)
		end

		--Set Tooltips
		button:SetScript("OnEnter", function()
				local link = GetSpellLink(spellID)
				GameTooltip:SetOwner(button, "ANCHOR_TOPRIGHT")
				GameTooltip:SetHyperlink(link)
				GameTooltip:Show()
				end
			)
		button:SetScript("OnLeave", function() GameTooltip:Hide() end)
		
		--Set Relative Positions if more then 1 mounts exists
		if (i == 1) then
			rowfirst = mount
		elseif (mod(i, 6) == 1) then
			mount:SetPoint("TOPLEFT", rowfirst, "BOTTOMLEFT", 0, 0)
			rowfirst = mount
		else
			mount:SetPoint("TOPLEFT", lastmount, "TOPRIGHT", 0, 0)
		end

		lastmount = mount
	end
end

function CheckBox_OnClick()
	local thispanel
	local _, mountname = strsplit("_", this:GetName())
	local id = this:GetID()
	for i, panel in pairs(Mountiful_Vars.panes) do
		if (strfind(this:GetName(), panel)) then
			thispanel = panel
		end
	end
	if not (Mountiful_Vars[thispanel]) then
		Mountiful_Vars[thispanel] = {}
		Mountiful_Vars[thispanel][mountname] = {}
	elseif not (Mountiful_Vars[thispanel][mountname]) then
		Mountiful_Vars[thispanel][mountname] = {}
	end

	if (this:GetChecked()) then
		Mountiful_Vars[thispanel][mountname]["checked"] = true
		Mountiful_Vars[thispanel][mountname]["id"] = id
	else
		Mountiful_Vars[thispanel][mountname]["checked"] = false
		Mountiful_Vars[thispanel][mountname]["id"] = id
	end
end

function Mountiful_Mount(panel)
	if IsMounted() then
		Dismount()
	else
		local temparray = {}
		if Mountiful_Vars[panel] then
			for index, value in pairs(Mountiful_Vars[panel]) do
				if (index ~= "isPet" and  Mountiful_Vars[panel][index]["checked"] == true) then
					temparray[#temparray+1] = Mountiful_Vars[panel][index]["id"]
				end
			end
			if (#temparray == 0) then
				message("No mounts are selected")
			else
				local num = random(1, #temparray)
				if (Mountiful_Vars[panel].isPet) then
					CallCompanion("CRITTER", temparray[num])
				else
					CallCompanion("MOUNT", temparray[num])
				end
			end
		else
			message("No mounts are selected")
		end
	end
end

function Mountiful_AddPanel(newpanel, isPet)
	local exists = false
	newpanellower = strlower(newpanel)
	if newpanellower == "hide" or newpanellower == "remove" or newpanellower == "add" or newpannellower == "smart" or newpannellower == "mounts" then
		message("Cannot add panel \""..newpanel.."\"")
	else
		for index, value in pairs(Mountiful_Vars.panes) do
			if newpanellower == strlower(value) then
				exists = true
			end
		end
		if exists then
			message("Cannot add panel \""..newpanel.."\", it already exists")
		else
			Mountiful_Vars.panes[#Mountiful_Vars.panes+1] = newpanel
			panel = Mountiful_CreatePanel(#Mountiful_Vars.panes, newpanel)
			if (not Mountiful_Vars[newpanel]) then
				Mountiful_Vars[newpanel] = { };
			end
			Mountiful_Vars[newpanel].isPet = isPet
			Mountiful_CreateMountSelectors(newpanel, panel)
		end
	end
end
function Mountiful_RemovePanel(panel)
	removed = false
	for index, value in pairs(Mountiful_Vars.panes) do
		if strlower(value) == strlower(panel) then
			Mountiful_Vars.panes[index] = nil
			getglobal(value):Hide()
			getglobal(value.."_Button"):Hide()
			if (Mountiful_Vars[value]) then
				Mountiful_Vars[value] = nil
			end
			message(value.." was removed")
			removed = true
			--Gets rid of nils in the panes array
			local temp = {}
			for i,v in pairs(Mountiful_Vars.panes) do
				temp[#temp+1] = v
			end
			Mountiful_Vars.panes = temp
			break
		end
	end
	if removed == false then
		message (panel.." was not removed")
	end
end
function Mountiful_SmartMount()
	local mountnum = GetNumCompanions("MOUNT")
	local mounts = Mountiful_Vars.Mounts
	local flyable
	local zoneName = GetZoneText()
	local ridingSkill = GetRidingSkill()
	local level = UnitLevel("player")
	local tmpnum
	
	for i, v in pairs(zoneFlyLevel) do
		if i == zoneName then
			if level >= zoneFlyLevel[i] then
				flyable = true
			else
				flyable = false
			end
		end
	end
	if mountnum ~= mounts.count then
		mounts.fastflyers = {}
		mounts.slowflyers = {}
		mounts.fastground = {}
		mounts.slowground = {}

		for i=1, mountnum do
			local _, mountname, spellID, icon, _ = GetCompanionInfo("MOUNT", i)
			local link = GetSpellLink(spellID)
			CreateFrame("GameTooltip", "MountifulTooltip", UIParent, "GameTooltipTemplate")
			GameTooltip_SetDefaultAnchor(MountifulTooltip, UIParent)
			MountifulTooltip:SetHyperlink(link)
			local text = _G["MountifulTooltipTextLeft"..3]:GetText()
			if strfind(text, "Outland") then
				if ridingSkill >= 300 and strfind(text, "very")then
					mounts.fastflyers[#mounts.fastflyers+1] = i
				else
					mounts.slowflyers[#mounts.slowflyers+1] = i
				end
			end
			if not strfind(text, "Outland") then
				if ridingSkill >= 150 and strfind(text, "very")then
					mounts.fastground[#mounts.fastground+1] = i
				else
					mounts.slowground[#mounts.slowground+1] = i
				end
			end

		end
		mounts.count = mountnum
	end
	if IsMounted() then
		Dismount()
	else
		if flyable and #mounts.fastflyers > 0 then
			tmpnum = random(1, #mounts.fastflyers)
			CallCompanion("MOUNT", mounts.fastflyers[tmpnum])
		elseif flyable and #mounts.slowflyers > 0 then
			tmpnum = random(1, #mounts.slowflyers)
			CallCompanion("MOUNT", mounts.slowflyers[tmpnum])
		elseif #mounts.fastground > 0 then
			tmpnum = random(1, #mounts.fastground)
			CallCompanion("MOUNT", mounts.fastground[tmpnum])
		elseif #mounts.slowground > 0 then
			tmpnum = random(1, #mounts.slowground)
			CallCompanion("MOUNT",mounts.slowground[tmpnum])
		else
			message("No mounts available")
		end
	end
end
function GetRidingSkill()
	for skillIndex = 1, GetNumSkillLines() do
		skillName, _, _, skillRank, _, _, _, _, _, _, _, _, _ = GetSkillLineInfo(skillIndex)
		if skillName == "Riding" then
			return skillRank
		end
	end
end
--- Adds Chat Messages
function message(msg)
	DEFAULT_CHAT_FRAME:AddMessage(tostring(msg))
end
